{
Copyright (c) 2006,2007 Mutsuo Saito, Makoto Matsumoto and Hiroshima
University. All rights reserved.

̃jbg͖ۏ؂łB
Ȃ鑹QƂĂAm܂B


BSDCZXpɒǉ
}


(*
Sfmt216091.pas Cu
coded by isaku@pb4.so-net.ne.jp
*)

{
jbg̏@ς
by Kanechan
}

unit Sfmt216091;

interface

  const MSEQ2 = 32;

  type
    mseq_t = 0..MSEQ2-1;
    idstr_t = string[63];

    state_t =
     record
         index       : integer;
         range       : integer;  (* NextIntEx őO͈̔ *)
         bse         : cardinal; (* NextIntEx őO̊l *)
         shift       : integer;  (* NextIntEx őÕVtg *)
         normal_sw   : integer;  (* NextNormal ŎcĂ *)
         normal_save : double;   (* NextNormal ̎c̒l *)
         x : array [0..6755] of cardinal;  (* ԃe[u *)
     end;

  function IdString:idstr_t;
  function IdString_m(m:mseq_t):idstr_t;
  procedure InitMt(s:cardinal);
  procedure InitMt_m(m:mseq_t; s:cardinal);
  procedure InitMtEx(key:array of cardinal; len:cardinal);
  procedure InitMtEx_m(m:mseq_t; key:array of cardinal; len:cardinal);
  function NextMt:cardinal;
  function NextMt64 : UInt64;
  function NextMt_m(m:mseq_t):cardinal;
  function NextInt(n:integer):integer;
  function NextInt_m(m:mseq_t;n:integer):integer;
  function NextUnif:double;
  function NextUnif_m(m:mseq_t):double;
  function NextIntEx(range_loc:integer):integer;
  function NextIntEx_m(m:mseq_t; range_loc:integer):integer;
  function NextChisq(n:double):double;
  function NextChisq_m(m:mseq_t; n:double):double;
  function NextGamma(a:double):double;
  function NextGamma_m(m:mseq_t; a:double):double;
  function NextGeometric(p:double):integer;
  function NextGeometric_m(m:mseq_t; p:double):integer;
  function NextTriangle:double;
  function NextTriangle_m(m:mseq_t):double;
  function NextExp:double;
  function NextExp_m(m:mseq_t):double;
  function NextNormal:double;
  function NextNormal_m(m:mseq_t):double;
  procedure NextUnitVect(var v:array of double; n:integer);
  procedure NextUnitVect_m(m:mseq_t; var v:array of double; n:integer);
  function NextBinomial(n:integer; p:double):integer;
  function NextBinomial_m(m:mseq_t; n:integer; p:double):integer;
  procedure NextBinormal(r:double; var a,b:double);
  procedure NextBinormal_m(m:mseq_t; r:double; var a,b:double);
  function NextBeta(a,b:double):double;
  function NextBeta_m(m:mseq_t; a,b:double):double;
  function NextPower(n:double):double;
  function NextPower_m(m:mseq_t; n:double):double;
  function NextLogistic:double;
  function NextLogistic_m(m:mseq_t):double;
  function NextCauchy:double;
  function NextCauchy_m(m:mseq_t):double;
  function NextFDist(n1,n2:double):double;
  function NextFDist_m(m:mseq_t; n1,n2:double):double;
  function NextPoisson(lambda:double):integer;
  function NextPoisson_m(m:mseq_t; lambda:double):integer;
  function NextTDist(n:double):double;
  function NextTDist_m(m:mseq_t; n:double):double;
  function NextWeibull(alpha:double):double;
  function NextWeibull_m(m:mseq_t; alpha:double):double;

implementation

uses math,Windows;

var DefaultMt : array [mseq_t] of state_t;

function IdString_m(m:mseq_t):idstr_t;
 begin
    IdString_m:='SFMT-216091:627-11-3-10-1:bff7bff7-bfffffff-bffffa7f-ffddfbfb'
 end;

function IdString:idstr_t; begin IdString:=IdString_m(0) end;

procedure period_certification(m:mseq_t);
  const parity:array[0..3]of cardinal=($F8000001,$89E80709,$3BD2B64B,$C64B1E4);
  var work,inner:cardinal; i,j:integer;
 begin
    with DefaultMt[m] do
     begin
        index:=6756; range:=0; normal_sw:=0; inner:=0;
        for i:=0 to 3 do inner:=inner xor x[i]and parity[i];
        i:=16;
        repeat
            inner:=inner xor inner shr i;
            i:=i shr 1
        until i=0;
        inner:=inner and 1;
        if inner=1 then exit;
        for i:=0 to 3 do
         begin
            j:=0; work:=1;
            repeat
                if (work and parity[i])<>0 Then
                 begin
                    x[i]:=x[i]xor work;
                    exit
                 end;
                inc(j); work:=work shl 1
            until j=32
         end
     end
 end;

procedure mfg00(var x : array of cardinal);
  var a,b,c,d:integer; y:cardinal;
 begin
    a:=0; b:=2508; c:=6748; d:=6752; 
    repeat
        y:=x[a+3]xor x[a+3]shl 24 xor x[a+2]shr 8 xor(x[b+3]shr 10)and$FFDDFBFB;
        x[a+3]:=y xor x[c+3]shr 8 xor x[d+3]shl 11;
        y:=x[a+2]xor x[a+2]shl 24 xor x[a+1]shr 8 xor(x[b+2]shr 10)and$BFFFFA7F;
        x[a+2]:=y xor(x[c+2]shr 8 or x[c+3]shl 24)xor x[d+2]shl 11;
        y:=x[a+1]xor x[a+1]shl 24 xor x[a]shr 8 xor(x[b+1]shr 10)and$BFFFFFFF;
        x[a+1]:=y xor(x[c+1]shr 8 or x[c+2]shl 24)xor x[d+1]shl 11;
        y:=x[a]xor x[a]shl 24 xor(x[b]shr 10)and$BFF7BFF7;
        x[a]:=y xor(x[c]shr 8 or x[c+1]shl 24)xor x[d]shl 11;
        c:=d; d:=a; inc(a,4); inc(b,4);
        if b=6756 Then b:=0
    until a=6756
 end;

procedure InitMt_m(m:mseq_t; s:cardinal);
  var p:cardinal;
 begin
    with DefaultMt[m] do
     begin
        x[0]:=s;
        for p:=1 To 6755 do
         begin
            s:=1812433253*(s xor(s shr 30))+p;
            x[p]:=s
         end;
        period_certification(m)
     end
 end;

procedure InitMt(s:cardinal); begin InitMt_m(0,s) end;

procedure InitMtEx_m(m:mseq_t; key:array of cardinal; len:cardinal);
  var r,i,j,c:cardinal;
 begin
    with DefaultMt[m] do
     begin
        for i:=0 to 6755 do x[i]:=$8B8B8B8B;
        if len+1>6756 then c:=len+1 Else c:=6756;
        r:=x[0]xor x[3372]xor x[6755]; r:=(r xor r shr 27)*1664525;
        inc(x[3372],r); inc(r,len); inc(x[3383],r); x[0]:=r; dec(c);
        i:=1; j:=0;
        while (j<c)and(j<len) do
         begin
            r:=x[i]xor x[(i+3372)mod 6756]xor x[(i+6755)mod 6756];
            r:=(r xor r shr 27)*1664525; inc(x[(i+3372)mod 6756],r);
            inc(r,key[j]+i); inc(x[(i+3383)mod 6756],r);
            x[i]:=r; i:=(i+1)mod 6756; inc(j)
         end;
        while j<c do
         begin
            r:=x[i] xor x[(i+3372)mod 6756]xor x[(i+6755)mod 6756];
            r:=(r xor r shr 27)*1664525; inc(x[(i+3372)mod 6756],r); inc(r,i);
            inc(x[(i+3383)mod 6756],r); x[i]:=r; i:=(i+1)mod 6756; inc(j)
         end;
        for j:=0 to 6755 do
         begin
            r:=x[i]+x[(i+3372)mod 6756]+x[(i+6755)mod 6756];
            r:=(r xor r shr 27)*1566083941;
            c:=(i+3372)mod 6756; x[c]:=x[c] xor r; dec(r,i);
            c:=(i+3383)mod 6756; x[c]:=x[c] xor r;
            x[i]:=r; i:=(i+1)mod 6756
         end;
        period_certification(m)
     end
 end;

procedure InitMtEx(key:array of cardinal; len:cardinal);
 begin InitMtEx_m(0,key,len) end;

//p
function NextMt64 : UInt64;
begin
Result := (NextMt shl 32) + NextMt;
end;

function NextMt:cardinal;
 begin
    with DefaultMt[NextMt_m(0) and (MSEQ2 - 1)] do
     begin
        if index=6756 Then
          begin
            mfg00(x);
            index:=0
          end;
         NextMt:=x[index]; inc(index)
     end
 end;

function NextMt_m(m:mseq_t):cardinal;
 begin
    with DefaultMt[m] do
     begin
        if index=6756 Then
          begin
            mfg00(x);
            index:=0
          end;
         NextMt_m:=x[index]; inc(index)
     end
 end;

function NextInt(n:integer):integer;
begin
    NextInt:=trunc(n*(1.0/4294967296.0)*NextMt)
 end;

function NextInt_m(m:mseq_t; n:integer):integer;
 begin
    NextInt_m:=trunc(n*(1.0/4294967296.0)*NextMt_m(m))
 end;

function NextUnif:double;
  var z,y:cardinal;
 begin
    z:=NextMt shr 11; y:=NextMt;
    NextUnif:=(y*2097152.0+z)*(1.0/9007199254740992.0)
 end;

function NextUnif_m(m:mseq_t):double;
  var z,y:cardinal;
 begin
    z:=NextMt_m(m)shr 11; y:=NextMt_m(m);
    NextUnif_m:=(y*2097152.0+z)*(1.0/9007199254740992.0)
 end;

(* ۂߌ덷̂ȂOȏ range_ ̐ *)
function NextIntEx(range_loc:integer):integer;
  var y_loc,base_loc,remain_loc,shift_loc:cardinal;
 begin
     with DefaultMt[0] do
      begin
        if range_loc<=0 then
         begin
            NextIntEx:=0; exit
         end;
        if range_loc<>range then
         begin
            range:=range_loc; bse:=range_loc; shift:=0;
            while bse<=1 shl 30 do
             begin
                bse:=bse shl 1; inc(shift);
             end
         end;
        repeat
            y_loc:=NextMt shr 1;
            if y_loc<bse then
             begin
                NextIntEx:=y_loc shr shift; exit
             end;
            base_loc:=bse; shift_loc:=shift; dec(y_loc,base_loc);
            remain_loc:=$80000000-base_loc;
            while remain_loc>=cardinal(range_loc) do
             begin
                while base_loc>remain_loc do
                 begin
                    base_loc:=base_loc shr 1; dec(shift_loc)
                 end;
                if y_loc<base_loc then
                 begin
                    NextIntEx:=y_loc shr shift_loc; exit
                 end;
                dec(y_loc,base_loc); dec(remain_loc,base_loc)
             end
        until false
     end
 end;

function NextIntEx_m(m:mseq_t; range_loc:integer):integer;
  var y_loc,base_loc,remain_loc,shift_loc:cardinal;
 begin
     with DefaultMt[m] do
      begin
        if range_loc<=0 then
         begin
            NextIntEx_m:=0; exit
         end;
        if range_loc<>range then
         begin
            range:=range_loc; bse:=range_loc; shift:=0;
            while bse<=1 shl 30 do
             begin
                bse:=bse shl 1; inc(shift);
             end
         end;
        repeat
            y_loc:=NextMt_m(m) shr 1;
            if y_loc<bse then
             begin
                NextIntEx_m:=y_loc shr shift; exit
             end;
            base_loc:=bse; shift_loc:=shift; dec(y_loc,base_loc);
            remain_loc:=$80000000-base_loc;
            while remain_loc>=cardinal(range_loc) do
             begin
                while base_loc>remain_loc do
                 begin
                    base_loc:=base_loc shr 1; dec(shift_loc)
                 end;
                if y_loc<base_loc then
                 begin
                    NextIntEx_m:=y_loc shr shift_loc; exit
                 end;
                dec(y_loc,base_loc); dec(remain_loc,base_loc)
             end
        until false
     end
 end;

(* Rx˂̃JCQ敪z *)
function NextChisq(n:double):double;
 begin
    NextChisq:=2*NextGamma(0.5*n)
 end;

function NextChisq_m(m:mseq_t; n:double):double;
 begin
    NextChisq_m:=2*NextGamma_m(m,0.5*n)
 end;

(* p[^̃K}z *)
function NextGamma(a:double):double;
  var t,u,x,y:double;
 begin
    if a>1 then
     begin
        t:=sqrt(2*a-1);
        repeat
            repeat
                repeat
                    repeat
                        x:=1-NextUnif; y:=2*NextUnif-1
                    until x*x+y*y<=1;
                    y:=y/x; x:=t*y+a-1
                until x>0;
                u:=(a-1)*ln(x/(a-1))-t*y
            until u>=-50.0
        until NextUnif<=(1+y*y)*exp(u)
     end else begin
        t:=2.7182818284590451/(a+2.7182818284590451);
        repeat
            if NextUnif<t then
             begin
                x:=power(NextUnif,1/a); y:=exp(-x)
             end else begin
                x:=1-ln(1-NextUnif); y:=power(x, a-1)
             end
        until NextUnif<y
     end;
    NextGamma:=x
 end;

function NextGamma_m(m:mseq_t; a:double):double;
  var t,u,x,y:double;
 begin
    if a>1 then
     begin
        t:=sqrt(2*a-1);
        repeat
            repeat
                repeat
                    repeat
                        x:=1-NextUnif_m(m); y:=2*NextUnif_m(m)-1
                    until x*x+y*y<=1;
                    y:=y/x; x:=t*y+a-1
                until x>0;
                u:=(a-1)*ln(x/(a-1))-t*y
            until u>=-50.0
        until NextUnif_m(m)<=(1+y*y)*exp(u)
     end else begin
        t:=2.7182818284590451/(a+2.7182818284590451);
        repeat
            if NextUnif_m(m)<t then
             begin
                x:=power(NextUnif_m(m),1/a); y:=exp(-x)
             end else begin
                x:=1-ln(1-NextUnif_m(m)); y:=power(x, a-1)
             end
        until NextUnif_m(m)<y
     end;
    NextGamma_m:=x
 end;

(* mo̊􉽕z *)
function NextGeometric(p:double):integer;
 begin
    NextGeometric:=Ceil(ln(1.0-NextUnif)/ln(1-p))
 end;

function NextGeometric_m(m:mseq_t; p:double):integer;
 begin
    NextGeometric_m:=Ceil(ln(1.0-NextUnif_m(m))/ln(1-p))
 end;

(* Opz *)
function NextTriangle:double;
  var a,b:double;
 begin
    a:=NextUnif; b:=NextUnif; NextTriangle:=a-b
 end;

function NextTriangle_m(m:mseq_t):double;
  var a,b:double;
 begin
    a:=NextUnif_m(m); b:=NextUnif_m(m); NextTriangle_m:=a-b
 end;

(* ςP̎wz *)
function NextExp:double;
 begin
    NextExp:=-ln(1-NextUnif)
 end;

function NextExp_m(m:mseq_t):double;
 begin
    NextExp_m:=-ln(1-NextUnif_m(m))
 end;

(* WKz(ő8.57) *)
function NextNormal:double;
  var t,u:double;
 begin
    with DefaultMt[0] do
     begin
        if normal_sw=0 then
         begin
            t:=sqrt(-2*ln(1.0-NextUnif));
            u:=3.1415926535897931*2*NextUnif;
            normal_save:=t*sin(u); normal_sw:=1;
            NextNormal:=t*cos(u); exit
         end else begin
            normal_sw:=0; NextNormal:=normal_save
         end
     end
 end;

function NextNormal_m(m:mseq_t):double;
  var t,u:double;
 begin
    with DefaultMt[m] do
     begin
        if normal_sw=0 then
         begin
            t:=sqrt(-2*ln(1.0-NextUnif_m(m)));
            u:=3.1415926535897931*2*NextUnif_m(m);
            normal_save:=t*sin(u); normal_sw:=1;
            NextNormal_m:=t*cos(u); exit
         end else begin
            normal_sw:=0; NextNormal_m:=normal_save
         end
     end
 end;

(* m̃_PʃxNg *)
procedure NextUnitVect(var v:array of double; n:integer);
  var i:integer; r:double;
 begin
    r:=0;
    for i:=0 to n-1 do
     begin
        v[i]:=NextNormal; r:=r+v[i]*v[i]
     end;
    if r=0.0 then r:=1.0;
    r:=sqrt(r);
    for i:=0 to n-1 do v[i]:=v[i]/r
 end;

procedure NextUnitVect_m(m:mseq_t; var v:array of double; n:integer);
  var i:integer; r:double;
 begin
    r:=0;
    for i:=0 to n-1 do
     begin
        v[i]:=NextNormal_m(m); r:=r+v[i]*v[i]
     end;
    if r=0.0 then r:=1.0;
    r:=sqrt(r);
    for i:=0 to n-1 do v[i]:=v[i]/r
 end;

(* p[^m,ôQz *)
function NextBinomial(n:integer; p:double):integer;
  var i,r:integer;
 begin
    r:=0;
    for i:=0 to n-1 do
     if NextUnif<p then inc(r);
    NextBinomial:=r
 end;

function NextBinomial_m(m:mseq_t; n:integer; p:double):integer;
  var i,r:integer;
 begin
    r:=0;
    for i:=0 to n-1 do
     if NextUnif_m(m)<p then inc(r);
    NextBinomial_m:=r
 end;

(* ֌Wq̂QϗʐKz *)
procedure NextBinormal(r:double; var a,b:double);
  var r1,r2,s:double;
 begin
    repeat
        r1:=2*NextUnif-1; r2:=2*NextUnif-1; s:=r1*r1+r2*r2
    until(s<=1)and(s>0);
    s:=-ln(s)/s; r1:=sqrt((1+r)*s)*r1;
    r2:=sqrt((1-r)*s)*r2; a:=r1+r2; b:=r1-r2
 end;

procedure NextBinormal_m(m:mseq_t; r:double; var a,b:double);
  var r1,r2,s:double;
 begin
    repeat
        r1:=2*NextUnif_m(m)-1; r2:=2*NextUnif_m(m)-1; s:=r1*r1+r2*r2
    until(s<=1)and(s>0);
    s:=-ln(s)/s; r1:=sqrt((1+r)*s)*r1;
    r2:=sqrt((1-r)*s)*r2; a:=r1+r2; b:=r1-r2
 end;

(* p[^`,ãx[^z *)
function NextBeta(a,b:double):double;
  var temp:double;
 begin
    temp:=NextGamma(a); NextBeta:=temp/(temp+NextGamma(b))
 end;

function NextBeta_m(m:mseq_t; a,b:double):double;
  var temp:double;
 begin
    temp:=NextGamma_m(m,a); NextBeta_m:=temp/(temp+NextGamma_m(m,b))
 end;

(* p[^m̗ݏ敪z *)
function NextPower(n:double):double;
 begin
    NextPower:=power(NextUnif,1.0/(n+1))
 end;

function NextPower_m(m:mseq_t; n:double):double;
 begin
    NextPower_m:=power(NextUnif_m(m),1.0/(n+1))
 end;

(* WXeBbNz *)
function NextLogistic:double;
  var r:double;
 begin
    repeat
        r:=NextUnif;
    until r>0;
    NextLogistic:=ln(r/(1-r))
 end;

function NextLogistic_m(m:mseq_t):double;
  var r:double;
 begin
    repeat
        r:=NextUnif_m(m);
    until r>0;
    NextLogistic_m:=ln(r/(1-r))
 end;

(* R[V[z *)
function NextCauchy:double;
  var x,y:double;
 begin
    repeat
        x:=1-NextUnif; y:=2*NextUnif-1
    until x*x+y*y<=1;
    NextCauchy:=y/x
 end;

function NextCauchy_m(m:mseq_t):double;
  var x,y:double;
 begin
    repeat
        x:=1-NextUnif_m(m); y:=2*NextUnif_m(m)-1
    until x*x+y*y<=1;
    NextCauchy_m:=y/x
 end;

(* Rx n1,n2 ̂ez *)
function NextFDist(n1,n2:double):double;
  var nc1,nc2:double;
 begin
    nc1:=NextChisq(n1); nc2:=NextChisq(n2);
    NextFDist:=(nc1*n2)/(nc2*n1)
 end;

function NextFDist_m(m:mseq_t; n1,n2:double):double;
  var nc1,nc2:double;
 begin
    nc1:=NextChisq_m(m,n1); nc2:=NextChisq_m(m,n2);
    NextFDist_m:=(nc1*n2)/(nc2*n1)
 end;

(* σɂ̃|A\z *)
function NextPoisson(lambda:double):integer;
  var k:integer;
 begin
    k:=0; lambda:=exp(lambda)*NextUnif;
    while lambda>1 do
     begin
        lambda:=lambda*NextUnif; inc(k)
     end;
    NextPoisson:=k;
 end;

function NextPoisson_m(m:mseq_t; lambda:double):integer;
  var k:integer;
 begin
    k:=0; lambda:=exp(lambda)*NextUnif_m(m);
    while lambda>1 do
     begin
        lambda:=lambda*NextUnif_m(m); inc(k)
     end;
    NextPoisson_m:=k;
 end;

(* Rxm̂z *)
function NextTDist(n:double):double;
  var a,b,c:double;
 begin
    if n<=2 then
     begin
        repeat a:=NextChisq(n) until a<>0;
        NextTDist:=NextNormal/Sqrt(a/n); exit
     end;
    repeat
        a:=NextNormal; b:=a*a/(n-2);
        c:=ln(1-NextUnif)/(1-0.5*n)
    until exp(-b-c)<=1-b;
    NextTDist:=a/sqrt((1-2.0/n)*(1-b))
 end;

function NextTDist_m(m:mseq_t; n:double):double;
  var a,b,c:double;
 begin
    if n<=2 then
     begin
        repeat a:=NextChisq_m(m,n) until a<>0;
        NextTDist_m:=NextNormal_m(m)/Sqrt(a/n); exit
     end;
    repeat
        a:=NextNormal_m(m); b:=a*a/(n-2);
        c:=ln(1-NextUnif_m(m))/(1-0.5*n)
    until exp(-b-c)<=1-b;
    NextTDist_m:=a/sqrt((1-2.0/n)*(1-b))
 end;

(* p[^̃Cuz *)
function NextWeibull(alpha:double):double;
 begin
    NextWeibull:=power(-ln(1-NextUnif),1/alpha)
 end;

function NextWeibull_m(m:mseq_t; alpha:double):double;
 begin
    NextWeibull_m:=power(-ln(1-NextUnif_m(m)),1/alpha)
 end;

 var i:cardinal;
begin
    Randomize;
    InitMt_m(0,GetTickCount);
    for i:=1 to MSEQ2-1 do InitMt_m(i,NextMt_m(0));

end.
